%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%                   MS 204                    %%%%%%%%%%%%%%%                   
%%%%%%%%%%%%%%%                     PC6                     %%%%%%%%%%%%%%%
%%%%%%%%    Elements finis et schema de Newmark sous Matlab        %%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% constantes physiques
sigma = 1;
T = 1;

%Prise en main des maillages

%......................................//...........................
% mettre les lignes correspondantes pour la lecture des 3 maillages:
%


%Représentation sous matlab à l'aide de la fonction trimesh
% figure(1) : représentation du maillage membraneh05.msh
% figure(2) : représentation du maillage membraneh02.msh
% figure(3) : représentation du maillage membraneh01.msh

figure(1)
trimesh(?,?,?);
figure(2)
trimesh(?,?,?);
figure(3)
trimesh(?,?,?);

% Nbpt correspond au nombre de noeuds total N du maillage
% N0 correspond au nombre de noeuds intérieurs : à déterminer
% On peut utiliser Refneu :  Refneu==1 si noeud extérieur, 0 si noeud intérieur.
%...................................................

% --------------------------------------------------------------
% calcul des matrices de masse et de raideur pour chaque maillage
% --------------------------------------------------------------

[M05,K05]=calculKM('membraneh05.msh',T,sigma);
[M02,K02]=calculKM('membraneh02.msh',T,sigma);
[M01,K01]=calculKM('membraneh01.msh',T,sigma);

% --------------------------------------------------------------
% Fréquences propres et déformées modales
% --------------------------------------------------------------

Nvp=45;%nombre de valeurs propres à calculer
[OM05,V05]=calculVP('membraneh05.msh',Nvp,T,sigma);
[OM02,V02]=calculVP('membraneh02.msh',Nvp,T,sigma);
[OM01,V01]=calculVP('membraneh01.msh',Nvp,T,sigma);

%Représentation de qq deformees modales%exemple 1 : premier mode; maillage h=05
figure
trimesh(?,?,?,?);

%Convergence des valeurs propres selon le raffinement du maillage
figure
??

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Maillage utilise pour le calcul a partir d'ici : h=0.2
[Nbpt,Nbtri,Coorneu,Refneu,Numtri,Reftri]=lecture_msh('membraneh02.msh');
[M,K]=calculKM('membraneh02.msh',T,sigma);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --------------------------------------------------------------
% Condition initiale
% --------------------------------------------------------------
A=2;
r0=0.5;
[U0,V0] = condition_initiale(?,?,A,r0);

%Représenter la condition initiale pour vérifier la fonction
?

% --------------------------------------------------------------
% Intégration en temps - schéma de Newmark
% --------------------------------------------------------------

%Constantes pour l'intégration temporelle
delta_t=0.01;%pas de temps
Tps_final=10;%temps total de la simulation
Tps_initial = 0;
alpha = 1/delta_t;%fréquence d'échantillonage
N_t = (Tps_final-Tps_initial)/delta_t; % le nombre d'iterations necessaires


% Matrice Amortissement EF
% -------------------------
a_1 =0;
a_2 =0;
C = a_1*M+a_2*K;

%Allocation memoire pour les sorties
U=zeros(Nbpt,N_t);%deplacement
V=zeros(Nbpt,N_t);%vitesse
A=zeros(Nbpt,N_t);%acceleration

%Constantes du schéma de Newmark
gamma = 0.5;
beta =1/4;

%Initialisation
% on initialise U et V a partir des conditions initiales
% calculées précédemment.
% -------------------------------------------------------
U(:,1)=??
V(:,1)=??

%Tous les calculs suivants n'ont lieu que sur les points interieurs
REFINT = find(Refneu==0);


%calcul de l'acceleration initiale
A(REFINT,1)=??
%calcul de la matrice S (intermediaire de calcul)
S = ??

%Boucle en temps
for k=2:N_t
    %Prediction
    Vstar = ??
    Ustar = ??
    %Calcul de l'acceleration   
    A(REFINT,k) = ??
    %Correction
    V(REFINT,k) = ??
    U(REFINT,k) = ??
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Animation de la solution
figure(5)
for uu=1:499
trisurf(Numtri,Coorneu(:,1),Coorneu(:,2),U(:,uu))
axis([-2 2 -2 2 -2 2])
view(-20,30)
pause(0.05)
end



